/*
 * 极简版的菜单，hover至空间时需要展现的空间菜单
 */

vPortalMainFrameElements.showNavSpaceMenu = {
    getData: function() {
        return false;
    }
}

//菜单区
var showNavSpaceMenu = function(_navArray,_spaceId,_dynamicTopData) {
    if (!_navArray || _navArray.length == 0) {
        return;
    }
    //显示空间区dom
    if(document.getElementById("spaceMenuArea")){
        document.getElementById("spaceMenuArea").style.display = "block";
        document.getElementById("spaceMenuArea").style.right = "80px";
        //处理菜单区的top值
        if(typeof(_dynamicTopData) !== "undefined" && typeof(_dynamicTopData.objTop) !== "undefined"){
            if(_dynamicTopData.objTop + 330 >_dynamicTopData.winH){
                document.getElementById("spaceMenuArea").style.top = (_dynamicTopData.winH - 350) + "px";
            }else{
                document.getElementById("spaceMenuArea").style.top = _dynamicTopData.objTop + "px";
            }
        }
    }else{
        return;
    }

    //菜单数据
    this._navArray = _navArray.menus || _navArray;
    //菜单总数
    this._len = this._navArray.length;
    //将序号拼进navJson，供tpl模板使用
    for (var i = 0; i < this._len; i++) {
        this._navArray[i].index = i;
    }
    //拼装navJson
    this.navJson = new Object;
    //计算菜单是否需要分页
    this.paging();
    //渲染菜单
    this._spaceMenuTpl = document.getElementById("tpl-showNavSpaceMenu").innerHTML;
    renderTpl(this.navJson, this._spaceMenuTpl, "spaceMenuArea");
    this.bindPaging();
}

//分页
showNavSpaceMenu.prototype.paging = function() {
    //单列菜单的宽度
    this._menuWidth = 135;
    //计算菜单区的宽度,50为spaceMenuArea的左右内间距
    if(document.getElementById("miniNav") || document.getElementById("topNav")){
        this._W = document.getElementsByTagName("body")[0].offsetWidth - 160 - 50 - 15;
    }else if(document.getElementById("leftNav")){
        this._W = document.getElementsByTagName("body")[0].offsetWidth - 80 - document.getElementById("leftNav").offsetWidth - 50 - 15;
    }else{
        this._W = document.getElementsByTagName("body")[0].offsetWidth;
    }
    //菜单分组，每屏为一组
    this._arrayGroups = [];
    //总页数，初始值：1
    this._pageNum = 1;
    //当前处于第N页，初始值：1
    this._pageNow = 1;
    //分页数组，里面的值表示第N个菜单需要换页了，初始值：1页，从下标0开始
    this._pageSlice = [0];
    //空间菜单区能显示多少列一级菜单
    this._eachpageMaxNum = Math.floor(this._W / this._menuWidth);
    //共有多少页
    this._pageNum = Math.ceil(this._len / this._eachpageMaxNum);
    this.navJson.currentNavGroupArray = new Array;
    //每级子菜单的高度，供计算位置使用
    this.navJson.eachLiHeight = 30;
    //将页数传入tpl供使用
    this.navJson.pageNum = this._pageNum;
    //将菜单数据分页
    if (this._pageNum > 1) {
        //计算分页位置
        for (var i = 0; i < this._pageNum; i++) {
            var _currentIndex = (i + 1) * this._eachpageMaxNum;
            _currentIndex = _currentIndex > this._len ? this._len : _currentIndex;
            this._pageSlice.push(_currentIndex);
        }
    }else{
        //计算分页位置
        this._pageSlice.push(this._len);
    }
    //将每一页的菜单json放入_arrayGroups中，将菜单按页分组
    for (var j = 0; j < (this._pageSlice.length - 1); j++) {
        var _arrayGroupsSlice = this._navArray.slice(this._pageSlice[j], this._pageSlice[j + 1]);
        this._arrayGroups.push(_arrayGroupsSlice);
    }
    this.navJson.currentNavGroupArray = this._arrayGroups[0];
    this.navJson.pageNow = this._pageNow - 1;
}

//为翻页按钮绑定事件
showNavSpaceMenu.prototype.bindPaging = function() {
    // 缓存dom：上一页、下一页
    var _navPrev = document.getElementById("spaceMenuNavPrev");
    var _navNext = document.getElementById("spaceMenuNavNext");
    //上一页
    if (_navPrev && _navPrev.attachEvent) {
        _navPrev.attachEvent('onclick', this.pagingPrev.bind(this));
    } else if(_navPrev) {
        _navPrev.addEventListener("click", this.pagingPrev.bind(this), false);
    }
    //下一页
    if (_navNext && _navNext.attachEvent) {
        _navNext.attachEvent('onclick', this.pagingNext.bind(this));
    } else if(_navNext) {
        _navNext.addEventListener("click", this.pagingNext.bind(this), false);
    }
}
//解除翻页按钮的事件绑定
showNavSpaceMenu.prototype.unBindPaging = function() {
    // 缓存dom：上一页、下一页
    var _navPrev = document.getElementById("spaceMenuNavPrev");
    var _navNext = document.getElementById("spaceMenuNavNext");
    //上一页
    if (_navPrev && _navPrev.attachEvent) {
        _navPrev.detachEvent('onclick', this.pagingPrev.bind(this));
    } else if(_navNext) {
        _navPrev.removeEventListener("click", this.pagingPrev.bind(this), false);
    }
    //下一页
    if (_navNext && _navNext.attachEvent) {
        _navNext.detachEvent('onclick', this.pagingNext.bind(this));
    } else if(_navNext) {
        _navNext.removeEventListener("click", this.pagingNext.bind(this), false);
    }
}
//下一页(向后)
showNavSpaceMenu.prototype.pagingNext = function() {
    if (this._pageNow == this._pageNum) {
        //当前页==总页数时
        return false;
    } else {
        //不是最后一页时：
        //解除翻页的事件绑定，避免内存泄漏
        this.unBindPaging();
        //渲染下一页
        this.navJson.currentNavGroupArray = this._arrayGroups[this._pageNow];
        this.navJson.pageNow = this._pageNow;
        renderTpl(this.navJson, this._spaceMenuTpl, "spaceMenuArea");
        //点亮"上一页"按钮
        document.getElementById("spaceMenuNavPrev").setAttribute("class", "navPrev");
        //点亮"下一页"按钮
        document.getElementById("spaceMenuNavNext").setAttribute("class", "navNext");
        //如果是倒数第二页，置灰"下一页"按钮
        if (this._pageNow == (this._pageNum - 1)) {
            document.getElementById("spaceMenuNavNext").setAttribute("class", "disabled navNext");
        }
        //当前页计数器+1
        this._pageNow++;
    }
    //因翻页按钮被重新渲染了，所以需要再次绑定
    this.bindPaging();
    document.getElementById("spaceMenuArea").style.right = "80px";
}
//上一页（向前）
showNavSpaceMenu.prototype.pagingPrev = function() {
    if (this._pageNow == 1) {
        //当前页==总页数时
        return false;
    } else {
        //不是第一页时：
        //解除翻页的事件绑定，避免内存泄漏
        this.unBindPaging();
        //渲染上一页
        this._pageNow--;
        this.navJson.currentNavGroupArray = this._arrayGroups[this._pageNow - 1];
        this.navJson.pageNow = this._pageNow - 1;
        renderTpl(this.navJson, this._spaceMenuTpl, "spaceMenuArea");
        //点亮"上一页"按钮
        document.getElementById("spaceMenuNavPrev").setAttribute("class", "navPrev");
        //点亮"下一页"按钮
        document.getElementById("spaceMenuNavNext").setAttribute("class", "navNext");
        //如果小于第二页，置灰"上一页"按钮
        if (this._pageNow < 2) {
            document.getElementById("spaceMenuNavPrev").setAttribute("class", "disabled navPrev");
        }
    }
    //因翻页按钮被重新渲染了，所以需要再次绑定
    this.bindPaging();
    document.getElementById("spaceMenuArea").style.right = "80px";
}

//显示子导航，并修正子导航top值
var miniNavShowChildAndFixPostion = function(_obj,_eachLiHeight) {
    //子菜单，如果没子菜单了，就return
    var _currentLevChildUl = _obj.parentNode.querySelector("ul");
    if(!_currentLevChildUl){
        return;
    }
    //子菜单的数量
    var _currentlevLen = _currentLevChildUl.children.length;
    //计算子菜单的高度
    var _currentLevChildHeight = _currentlevLen * _eachLiHeight;
    //兄弟元素lev
    var _currentLevSiblingDiv = _obj.parentNode.querySelector(".lev");
    //菜单区的宽度
    var _spaceMenuAreaWidth = document.body.clientWidth - 200;
    //光标所在位置的菜单对于window的间距
    var _currentLevLiOfffsetTop = _obj.offsetParent.offsetTop;
    var _currentLevBottomOffset = _currentLevLiOfffsetTop + _currentLevChildHeight;
    var _currentLevLiOfffsetLeft = _obj.offsetParent.offsetLeft;
    var _currentLevRightOffset = _currentLevLiOfffsetLeft + 135;
    //空间菜单区的高度
    var _miniNavListHeight = 300;
    //如果当前菜单的offsetTop + 子菜单高度 > 菜单区的高度300px，说明子菜单溢出屏幕了，需要修正top值
    if (_currentLevBottomOffset > _miniNavListHeight) {
        //如果子菜单的底部位置>页面菜单区的高度，向上挪挪
        if (_currentLevChildHeight > _miniNavListHeight) {
            //调整top值
            var _newMarginTop = (_miniNavListHeight - _currentLevBottomOffset > 0 ? 0 : (_miniNavListHeight - _currentLevBottomOffset));
            _currentLevSiblingDiv.style.marginTop = _newMarginTop + "px";
        }
    }
    //如果当前菜单的offsetLeft + 子菜单宽度 > 菜单区的宽度，说明子菜单溢出菜单区右侧了，需要加宽菜单区。
    if (_currentLevRightOffset + 135 > _spaceMenuAreaWidth) {
        document.getElementById("spaceMenuArea").style.right = "0px";
    }else{
        document.getElementById("spaceMenuArea").style.right = "80px";
    }
    //显示兄弟元素lev
    if(_currentLevSiblingDiv) {
        _currentLevSiblingDiv.style.display = "block";
    }
}

//隐藏子导航
var miniNavHideChildAndFixPostion = function(_obj) {
    //隐藏兄弟元素lev
    var _currentLevSiblingDiv = _obj.parentNode.querySelector(".lev");
    if(_currentLevSiblingDiv) {
        _currentLevSiblingDiv.style.display = "none";
    }
}

//显示当前层级的导航
var miniNavShowThisLev = function(_obj) {
    _obj.style.display = "block";
}

//隐藏当前层级的导航
var miniNavHideThisLev = function(_obj) {
    _obj.style.display = "none";
}